#ifndef EYEMAPWIDGET_H
#define EYEMAPWIDGET_H

#include <QWidget>
#include <QTimer>

#include "spdlog/spdlog.h"


struct OneChannelInfo;

namespace Ui {
class EyeMapWidget;
}

class EyeMapWidget : public QWidget
{
    Q_OBJECT

public:
    explicit EyeMapWidget(QWidget *parent = nullptr);
    ~EyeMapWidget();

    /* 开始采集 */
    void startCapture();
    // /* 设置显示的个数 */
    // void setShowNum(int num) { m_showNum = num; }
    // /* 获取显示的个数 */
    // int getShowNum() { return m_showNum; }

private slots:
    void do_exit();
    /* 时间跳动槽函数 */
    void do_timeWalk();
    /* 设置眼图个数页面的槽函数 */
    void do_pBtnSettingNum();
    /* 设置眼图参数的槽函数 */
    void do_pBtnSettingParam();

private:
    /* 初始化眼图 */
    void initEyeMap();
    /* 排列眼图布局 */
    void eyeMapLayout();
    /* 清空数据矩阵内容 */
    void resetMatrix();

private:
    Ui::EyeMapWidget *ui;
    std::shared_ptr<spdlog::logger> m_logger = nullptr;
    QTimer m_timerTime;                         /* 时间定时器 */

    /* 布局信息 */
    int m_marginLeft = 32;                      /* 左侧边距 */
    int m_marginTop = 18;                       /* 顶部边距 */
    int m_marginRight = 32;                     /* 右侧边距 */
    int m_marginBottom = 32;                    /* 底部边距 */
    int m_spacing = 16;                         /* 间距 */

    /* 属性信息 */
    // int m_showNum = 0;                          /* 显示的眼图个数 */
    int m_row = 4;                              /* 行 */
    int m_column = 2;                           /* 列 */
};

#endif /* EYEMAPWIDGET_H */
