#ifndef PARAMCONFIG_H
#define PARAMCONFIG_H

#include <QDialog>
#include "spdlog/spdlog.h"
#include "EyeMapInfo.h"

// #include <QStandardItemModel>
// #include <QTableView>

struct OneEyeMapInfo;
class OneParamItem;

namespace Ui {
class ParamConfig;
}

class ParamConfig : public QDialog
{
    Q_OBJECT

public:
    explicit ParamConfig(QWidget *parent = nullptr);
    ~ParamConfig();

    /* 创建项 */
    void createItem(const QList<OneEyeMapInfo> &listInfo);

protected:
    /* 事件过滤器 */
    bool eventFilter(QObject *watched, QEvent *event) override;

private:
    // /* 初始化表格 */
    // void initTable();
    // /* 初始化数据 */
    // void initData();

    /* 布局item */
    void layoutItem();
    /* 更新全局的眼图数据 */
    void updateEyeMapInfo();
    /* 获取时间刻度对应的字符串 */
    QString getTimeGridValueStr(OscTimeGridValue value);

private slots:
    /* 关闭按钮 */
    void do_pBtn_close();
    /* 保存按钮 */
    void do_pBtn_save();
    /* 点击了取消按钮 */
    void do_pBtn_cancel();

public:
    bool isOk = false;


private:
    Ui::ParamConfig *ui;
    std::shared_ptr<spdlog::logger> m_logger = nullptr;

    QList<OneParamItem*> m_listItem;

    // QStandardItemModel *m_model = nullptr;
    // QTableView *m_tableView = nullptr;
};

#endif // PARAMCONFIG_H
